﻿<#	
	.DESCRIPTION
		Listet Client Cerftificates mit verschiedenem Status auf.

	.PARAMETER OutConsoleGridView
		List the Client Certificate Report in a Console-based GridView


	.NOTES
	===========================================================================
	 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2021 v5.8.191
	 Created on:   	26.07.2021 17:27
	 Created by:   	hinde
	 Organization: 	GWDG
	 Filename:     	ClientCertReport.ps1
	===========================================================================
#>
param
(
	[switch]$OutConsoleGridView = $false
)
if (-not (Get-Module -ListAvailable -Name Microsoft.PowerShell.ConsoleGuiTools))
{
	Write-Output "Um das Cmdlet Out-ConsoleGridView zur Verfügung zu haben, dass in diesem Skript verwendet wird,"
	Write-Output "lesen Sie die Anweisungen der folgende README.md des Repositories unter https://gitlab.gwdg.de/pki/geant-tcs/automate/psscripts"
	Exit 1
}

$cred = Get-Credential
$setClientCertReporttUrl = "https://cert-manager.com/api/report/v1/client-certificates"
$orgIds = Read-Host "OrganizationID"
[int32]$certStatus = Read-Host "Welcher Zertifikat-Status [0(Any), 2(Enrolled), 3(Revoked), 4(Expired), 5(Enrolled - Pending Download), 6(Not Enrolled)]"
[int32]$certDateAttr = Read-Host "Welches Zertifikat-Datumattribut [0(Enrolled Date), 1(Downloaded Date), 2(Revocation Date), 3(Expiration Date)]"
$to = (Get-Date -Format "yyyy-MM-ddTHH:mm:ssZ").ToString()
$howManyMonthBack = Read-Host "Wieviele Monate vom heutigen Datum zurück [positive Ganzzahl - wird vom Skript umgerechnet]"
[int32]$howManyMonth = 0
$result = [int32]::TryParse($howManyMonthBack,[ref]$howManyMonth)
if ($result)
{
	$howManyMonth = $howManyMonth * -1
}
else
{
	Write-Error "Konvertierung fehlgeschlagen"
	exit 1
}
[System.DateTime]$monthBack = Get-Date
$from = $monthBack.AddMonths($howManyMonth).ToString("yyyy-MM-ddTHH:mm:ssZ")

$headers = @{
	'Content-Type' = 'application/json;charset=utf-8'
	'login' = $cred.UserName
	'password' = ConvertFrom-SecureString -SecureString $cred.Password -AsPlainText
	'customerUri' = 'DFN'
}

#$body = '{"from":"2021-05-01T00:00:00.000Z","to":"2021-07-30T00:00:00.000Z","organizationIds":[' + $orgIds + '],"certificateStatus":0,"certificateDateAttribute":0}'
$body = '{"from":"' + $from + '","to":"' + $to + '","organizationIds":[' + $orgIds + '],"certificateStatus":' + $certStatus + ',"certificateDateAttribute":0}'


if ($OutConsoleGridView)
{
	$clientCertReport = Invoke-RestMethod -Uri $setClientCertReporttUrl -Method Post -Headers $headers -Body $body
	$listCerts = $clientCertReport.reports | Out-ConsoleGridView
	Clear-Host
	$listCerts
}
else
{
	Invoke-RestMethod -Uri $setClientCertReporttUrl -Method Post -Headers $headers -Body $body
}



# SIG # Begin signature block
# MIIwRgYJKoZIhvcNAQcCoIIwNzCCMDMCAQExDzANBglghkgBZQMEAgEFADB5Bgor
# BgEEAYI3AgEEoGswaTA0BgorBgEEAYI3AgEeMCYCAwEAAAQQH8w7YFlLCE63JNLG
# KX7zUQIBAAIBAAIBAAIBAAIBADAxMA0GCWCGSAFlAwQCAQUABCA8eIhGkjHCDPLW
# Nte15hIw6yc0s4v8vz/JEaCcI8QT9aCCKUcwggQyMIIDGqADAgECAgEBMA0GCSqG
# SIb3DQEBBQUAMHsxCzAJBgNVBAYTAkdCMRswGQYDVQQIDBJHcmVhdGVyIE1hbmNo
# ZXN0ZXIxEDAOBgNVBAcMB1NhbGZvcmQxGjAYBgNVBAoMEUNvbW9kbyBDQSBMaW1p
# dGVkMSEwHwYDVQQDDBhBQUEgQ2VydGlmaWNhdGUgU2VydmljZXMwHhcNMDQwMTAx
# MDAwMDAwWhcNMjgxMjMxMjM1OTU5WjB7MQswCQYDVQQGEwJHQjEbMBkGA1UECAwS
# R3JlYXRlciBNYW5jaGVzdGVyMRAwDgYDVQQHDAdTYWxmb3JkMRowGAYDVQQKDBFD
# b21vZG8gQ0EgTGltaXRlZDEhMB8GA1UEAwwYQUFBIENlcnRpZmljYXRlIFNlcnZp
# Y2VzMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAvkCd9G7h6naHHE1F
# RI6+RsiDBp3BKv4YH47kAvrzq11QihYxC5oG0MVwIs1JLVRjzLZuaEYLU+rLTCTA
# vHJO6vEVrvRUmhIKw3qyM2Di2olV8yJY897cz++DhqKMlE+faPKYkEaEJ8d2v+PM
# NSyLXgdkZYLASLCokflhn3YgUKiRx2a163hiA1bwihoT6jGjHqCZ/Tj29icyWG8H
# 9Wu4+xQrr7eqzNZjX3OM2gWZqDioyxd4NlGs6Z70eDqNzw/ZQuKYDKsvnw4B3u+f
# mUnxLd+sdE0bmLVHxeUp0fmQGMdinL6DxyZ7Poolx8DdneY1aBAgnY/Y3tLDhJwN
# XugvyQIDAQABo4HAMIG9MB0GA1UdDgQWBBSgEQojPpbxB+zirynvgqV/0DCktDAO
# BgNVHQ8BAf8EBAMCAQYwDwYDVR0TAQH/BAUwAwEB/zB7BgNVHR8EdDByMDigNqA0
# hjJodHRwOi8vY3JsLmNvbW9kb2NhLmNvbS9BQUFDZXJ0aWZpY2F0ZVNlcnZpY2Vz
# LmNybDA2oDSgMoYwaHR0cDovL2NybC5jb21vZG8ubmV0L0FBQUNlcnRpZmljYXRl
# U2VydmljZXMuY3JsMA0GCSqGSIb3DQEBBQUAA4IBAQAIVvwC8Jvo/6T61nvGRIDO
# T8TF9gBYzKa2vBRJaAR26ObuXewCD2DWjVAYTyZOAePmsKXuv7x0VEG//fwSuMdP
# WvSJYAV/YLcFSvP28cK/xLl0hrYtfWvM0vNG3S/G4GrDwzQDLH2W3VrCDqcKmcEF
# i6sML/NcOs9sN1UJh95TQGxY7/y2q2VuBPYb3DzgWhXGntnxWUgwIWUDbOzpIXPs
# mwOh4DetoBUYj/q6As6nLKkQEyzU5QgmqyKXYPiQXnTUoppTvfKpaOCibsLXbLGj
# D56/62jnVvKu8uMrODoJgbVrhde+Le0/GreyY+L1YiyC1GoAQVDxOYOflek2lphu
# MIIFbzCCBFegAwIBAgIQSPyTtGBVlI02p8mKidaUFjANBgkqhkiG9w0BAQwFADB7
# MQswCQYDVQQGEwJHQjEbMBkGA1UECAwSR3JlYXRlciBNYW5jaGVzdGVyMRAwDgYD
# VQQHDAdTYWxmb3JkMRowGAYDVQQKDBFDb21vZG8gQ0EgTGltaXRlZDEhMB8GA1UE
# AwwYQUFBIENlcnRpZmljYXRlIFNlcnZpY2VzMB4XDTIxMDUyNTAwMDAwMFoXDTI4
# MTIzMTIzNTk1OVowVjELMAkGA1UEBhMCR0IxGDAWBgNVBAoTD1NlY3RpZ28gTGlt
# aXRlZDEtMCsGA1UEAxMkU2VjdGlnbyBQdWJsaWMgQ29kZSBTaWduaW5nIFJvb3Qg
# UjQ2MIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEAjeeUEiIEJHQu/xYj
# ApKKtq42haxH1CORKz7cfeIxoFFvrISR41KKteKW3tCHYySJiv/vEpM7fbu2ir29
# BX8nm2tl06UMabG8STma8W1uquSggyfamg0rUOlLW7O4ZDakfko9qXGrYbNzszwL
# DO/bM1flvjQ345cbXf0fEj2CA3bm+z9m0pQxafptszSswXp43JJQ8mTHqi0Eq8Nq
# 6uAvp6fcbtfo/9ohq0C/ue4NnsbZnpnvxt4fqQx2sycgoda6/YDnAdLv64IplXCN
# /7sVz/7RDzaiLk8ykHRGa0c1E3cFM09jLrgt4b9lpwRrGNhx+swI8m2JmRCxrds+
# LOSqGLDGBwF1Z95t6WNjHjZ/aYm+qkU+blpfj6Fby50whjDoA7NAxg0POM1nqFOI
# +rgwZfpvx+cdsYN0aT6sxGg7seZnM5q2COCABUhA7vaCZEao9XOwBpXybGWfv1Vb
# HJxXGsd4RnxwqpQbghesh+m2yQ6BHEDWFhcp/FycGCvqRfXvvdVnTyheBe6QTHrn
# xvTQ/PrNPjJGEyA2igTqt6oHRpwNkzoJZplYXCmjuQymMDg80EY2NXycuu7D1fkK
# dvp+BRtAypI16dV60bV/AK6pkKrFfwGcELEW/MxuGNxvYv6mUKe4e7idFT/+IAx1
# yCJaE5UZkADpGtXChvHjjuxf9OUCAwEAAaOCARIwggEOMB8GA1UdIwQYMBaAFKAR
# CiM+lvEH7OKvKe+CpX/QMKS0MB0GA1UdDgQWBBQy65Ka/zWWSC8oQEJwIDaRXBeF
# 5jAOBgNVHQ8BAf8EBAMCAYYwDwYDVR0TAQH/BAUwAwEB/zATBgNVHSUEDDAKBggr
# BgEFBQcDAzAbBgNVHSAEFDASMAYGBFUdIAAwCAYGZ4EMAQQBMEMGA1UdHwQ8MDow
# OKA2oDSGMmh0dHA6Ly9jcmwuY29tb2RvY2EuY29tL0FBQUNlcnRpZmljYXRlU2Vy
# dmljZXMuY3JsMDQGCCsGAQUFBwEBBCgwJjAkBggrBgEFBQcwAYYYaHR0cDovL29j
# c3AuY29tb2RvY2EuY29tMA0GCSqGSIb3DQEBDAUAA4IBAQASv6Hvi3SamES4aUa1
# qyQKDKSKZ7g6gb9Fin1SB6iNH04hhTmja14tIIa/ELiueTtTzbT72ES+BtlcY2fU
# QBaHRIZyKtYyFfUSg8L54V0RQGf2QidyxSPiAjgaTCDi2wH3zUZPJqJ8ZsBRNraJ
# AlTH/Fj7bADu/pimLpWhDFMpH2/YGaZPnvesCepdgsaLr4CnvYFIUoQx2jLsFeSm
# TD1sOXPUC4U5IOCFGmjhp0g4qdE2JXfBjRkWxYhMZn0vY86Y6GnfrDyoXZ3JHFuu
# 2PMvdM+4fvbXg50RlmKarkUT2n/cR/vfw1Kf5gZV6Z2M8jpiUbzsJA8p1FiAhORF
# e1rYMIIFgzCCA2ugAwIBAgIORea7A4Mzw4VlSOb/RVEwDQYJKoZIhvcNAQEMBQAw
# TDEgMB4GA1UECxMXR2xvYmFsU2lnbiBSb290IENBIC0gUjYxEzARBgNVBAoTCkds
# b2JhbFNpZ24xEzARBgNVBAMTCkdsb2JhbFNpZ24wHhcNMTQxMjEwMDAwMDAwWhcN
# MzQxMjEwMDAwMDAwWjBMMSAwHgYDVQQLExdHbG9iYWxTaWduIFJvb3QgQ0EgLSBS
# NjETMBEGA1UEChMKR2xvYmFsU2lnbjETMBEGA1UEAxMKR2xvYmFsU2lnbjCCAiIw
# DQYJKoZIhvcNAQEBBQADggIPADCCAgoCggIBAJUH6HPKZvnsFMp7PPcNCPG0RQss
# grRIxutbPK6DuEGSMxSkb3/pKszGsIhrxbaJ0cay/xTOURQh7ErdG1rG1ofuTToV
# Bu1kZguSgMpE3nOUTvOniX9PeGMIyBJQbUJmL025eShNUhqKGoC3GYEOfsSKvGRM
# IRxDaNc9PIrFsmbVkJq3MQbFvuJtMgamHvm566qjuL++gmNQ0PAYid/kD3n16qIf
# KtJwLnvnvJO7bVPiSHyMEAc4/2ayd2F+4OqMPKq0pPbzlUoSB239jLKJz9CgYXfI
# WHSw1CM69106yqLbnQneXUQtkPGBzVeS+n68UARjNN9rkxi+azayOeSsJDa38O+2
# HBNXk7besvjihbdzorg1qkXy4J02oW9UivFyVm4uiMVRQkQVlO6jxTiWm05OWgtH
# 8wY2SXcwvHE35absIQh1/OZhFj931dmRl4QKbNQCTXTAFO39OfuD8l4UoQSwC+n+
# 7o/hbguyCLNhZglqsQY6ZZZZwPA1/cnaKI0aEYdwgQqomnUdnjqGBQCe24DWJfnc
# BZ4nWUx2OVvq+aWh2IMP0f/fMBH5hc8zSPXKbWQULHpYT9NLCEnFlWQaYw55PfWz
# jMpYrZxCRXluDocZXFSxZba/jJvcE+kNb7gu3GduyYsRtYQUigAZcIN5kZeR1Bon
# vzceMgfYFGM8KEyvAgMBAAGjYzBhMA4GA1UdDwEB/wQEAwIBBjAPBgNVHRMBAf8E
# BTADAQH/MB0GA1UdDgQWBBSubAWjkxPioufi1xzWx/B/yGdToDAfBgNVHSMEGDAW
# gBSubAWjkxPioufi1xzWx/B/yGdToDANBgkqhkiG9w0BAQwFAAOCAgEAgyXt6NH9
# lVLNnsAEoJFp5lzQhN7craJP6Ed41mWYqVuoPId8AorRbrcWc+ZfwFSY1XS+wc3i
# EZGtIxg93eFyRJa0lV7Ae46ZeBZDE1ZXs6KzO7V33EByrKPrmzU+sQghoefEQzd5
# Mr6155wsTLxDKZmOMNOsIeDjHfrYBzN2VAAiKrlNIC5waNrlU/yDXNOd8v9EDERm
# 8tLjvUYAGm0CuiVdjaExUd1URhxN25mW7xocBFymFe944Hn+Xds+qkxV/ZoVqW/h
# pvvfcDDpw+5CRu3CkwWJ+n1jez/QcYF8AOiYrg54NMMl+68KnyBr3TsTjxKM4kEa
# SHpzoHdpx7Zcf4LIHv5YGygrqGytXm3ABdJ7t+uA/iU3/gKbaKxCXcPu9czc8FB1
# 0jZpnOZ7BN9uBmm23goJSFmH63sUYHpkqmlD75HHTOwY3WzvUy2MmeFe8nI+z1TI
# vWfspA9MRf/TuTAjB0yPEL+GltmZWrSZVxykzLsViVO6LAUP5MSeGbEYNNVMnbrt
# 9x+vJJUEeKgDu+6B5dpffItKoZB0JaezPkvILFa9x8jvOOJckvB595yEunQtYQEg
# fn7R8k8HWV+LLUNS60YMlOH1Zkd5d9VUWx+tJDfLRVpOoERIyNiwmcUVhAn21klJ
# wGW45hpxbqCo8YLoRT5s1gLXCmeDBVrJpBAwggYcMIIEBKADAgECAhAz1wiokUBT
# GeKlu9M5ua1uMA0GCSqGSIb3DQEBDAUAMFYxCzAJBgNVBAYTAkdCMRgwFgYDVQQK
# Ew9TZWN0aWdvIExpbWl0ZWQxLTArBgNVBAMTJFNlY3RpZ28gUHVibGljIENvZGUg
# U2lnbmluZyBSb290IFI0NjAeFw0yMTAzMjIwMDAwMDBaFw0zNjAzMjEyMzU5NTla
# MFcxCzAJBgNVBAYTAkdCMRgwFgYDVQQKEw9TZWN0aWdvIExpbWl0ZWQxLjAsBgNV
# BAMTJVNlY3RpZ28gUHVibGljIENvZGUgU2lnbmluZyBDQSBFViBSMzYwggGiMA0G
# CSqGSIb3DQEBAQUAA4IBjwAwggGKAoIBgQC70f4et0JbePWQp64sg/GNIdMwhoV7
# 39PN2RZLrIXFuwHP4owoEXIEdiyBxasSekBKxRDogRQ5G19PB/YwMDB/NSXlwHM9
# QAmU6Kj46zkLVdW2DIseJ/jePiLBv+9l7nPuZd0o3bsffZsyf7eZVReqskmoPBBq
# OsMhspmoQ9c7gqgZYbU+alpduLyeE9AKnvVbj2k4aOqlH1vKI+4L7bzQHkNDbrBT
# jMJzKkQxbr6PuMYC9ruCBBV5DFIg6JgncWHvL+T4AvszWbX0w1Xn3/YIIq620QlZ
# 7AGfc4m3Q0/V8tm9VlkJ3bcX9sR0gLqHRqwG29sEDdVOuu6MCTQZlRvmcBMEJd+P
# uNeEM4xspgzraLqVT3xE6NRpjSV5wyHxNXf4T7YSVZXQVugYAtXueciGoWnxG06U
# E2oHYvDQa5mll1CeHDOhHu5hiwVoHI717iaQg9b+cYWnmvINFD42tRKtd3V6zOdG
# NmqQU8vGlHHeBzoh+dYyZ+CcblSGoGSgg8sCAwEAAaOCAWMwggFfMB8GA1UdIwQY
# MBaAFDLrkpr/NZZILyhAQnAgNpFcF4XmMB0GA1UdDgQWBBSBMpJBKyjNRsjEosYq
# ORLsSKk/FDAOBgNVHQ8BAf8EBAMCAYYwEgYDVR0TAQH/BAgwBgEB/wIBADATBgNV
# HSUEDDAKBggrBgEFBQcDAzAaBgNVHSAEEzARMAYGBFUdIAAwBwYFZ4EMAQMwSwYD
# VR0fBEQwQjBAoD6gPIY6aHR0cDovL2NybC5zZWN0aWdvLmNvbS9TZWN0aWdvUHVi
# bGljQ29kZVNpZ25pbmdSb290UjQ2LmNybDB7BggrBgEFBQcBAQRvMG0wRgYIKwYB
# BQUHMAKGOmh0dHA6Ly9jcnQuc2VjdGlnby5jb20vU2VjdGlnb1B1YmxpY0NvZGVT
# aWduaW5nUm9vdFI0Ni5wN2MwIwYIKwYBBQUHMAGGF2h0dHA6Ly9vY3NwLnNlY3Rp
# Z28uY29tMA0GCSqGSIb3DQEBDAUAA4ICAQBfNqz7+fZyWhS38Asd3tj9lwHS/QHu
# mS2G6Pa38Dn/1oFKWqdCSgotFZ3mlP3FaUqy10vxFhJM9r6QZmWLLXTUqwj3ahED
# CHd8vmnhsNufJIkD1t5cpOCy1rTP4zjVuW3MJ9bOZBHoEHJ20/ng6SyJ6UnTs5eW
# Bgrh9grIQZqRXYHYNneYyoBBl6j4kT9jn6rNVFRLgOr1F2bTlHH9nv1HMePpGoYd
# 074g0j+xUl+yk72MlQmYco+VAfSYQ6VK+xQmqp02v3Kw/Ny9hA3s7TSoXpUrOBZj
# BXXZ9jEuFWvilLIq0nQ1tZiao/74Ky+2F0snbFrmuXZe2obdq2TWauqDGIgbMYL1
# iLOUJcAhLwhpAuNMu0wqETDrgXkG4UGVKtQg9guT5Hx2DJ0dJmtfhAH2KpnNr97H
# 8OQYok6bLyoMZqaSdSa+2UA1E2+upjcaeuitHFFjBypWBmztfhj24+xkc6ZtCDaL
# rw+ZrnVrFyvCTWrDUUZBVumPwo3/E3Gb2u2e05+r5UWmEsUUWlJBl6MGAAjF5hzq
# J4I8O9vmRsTvLQA1E802fZ3lqicIBczOwDYOSxlP0GOabb/FKVMxItt1UHeG0PL4
# au5rBhs+hSMrl8h+eplBDN1Yfw6owxI9OjWb4J0sjBeBVESoeh2YnZZ/WVimVGX/
# UUIL+Efrz/jlvzCCBlkwggRBoAMCAQICDQHsHJJA3v0uQF18R3QwDQYJKoZIhvcN
# AQEMBQAwTDEgMB4GA1UECxMXR2xvYmFsU2lnbiBSb290IENBIC0gUjYxEzARBgNV
# BAoTCkdsb2JhbFNpZ24xEzARBgNVBAMTCkdsb2JhbFNpZ24wHhcNMTgwNjIwMDAw
# MDAwWhcNMzQxMjEwMDAwMDAwWjBbMQswCQYDVQQGEwJCRTEZMBcGA1UEChMQR2xv
# YmFsU2lnbiBudi1zYTExMC8GA1UEAxMoR2xvYmFsU2lnbiBUaW1lc3RhbXBpbmcg
# Q0EgLSBTSEEzODQgLSBHNDCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoCggIB
# APAC4jAj+uAb4Zp0s691g1+pR1LHYTpjfDkjeW10/DHkdBIZlvrOJ2JbrgeKJ+5X
# o8Q17bM0x6zDDOuAZm3RKErBLLu5cPJyroz3mVpddq6/RKh8QSSOj7rFT/82Qaun
# Lf14TkOI/pMZF9nuMc+8ijtuasSI8O6X9tzzGKBLmRwOh6cm4YjJoOWZ4p70nEw/
# XVvstu/SZc9FC1Q9sVRTB4uZbrhUmYqoMZI78np9/A5Y34Fq4bBsHmWCKtQhx5T+
# QpY78Quxf39GmA6HPXpl69FWqS69+1g9tYX6U5lNW3TtckuiDYI3GQzQq+pawe8P
# 1Zm5P/RPNfGcD9M3E1LZJTTtlu/4Z+oIvo9Jev+QsdT3KRXX+Q1d1odDHnTEcCi0
# gHu9Kpu7hOEOrG8NubX2bVb+ih0JPiQOZybH/LINoJSwspTMe+Zn/qZYstTYQRLB
# Vf1ukcW7sUwIS57UQgZvGxjVNupkrs799QXm4mbQDgUhrLERBiMZ5PsFNETqCK6d
# SWcRi4LlrVqGp2b9MwMB3pkl+XFu6ZxdAkxgPM8CjwH9cu6S8acS3kISTeypJuV3
# AqwOVwwJ0WGeJoj8yLJN22TwRZ+6wT9Uo9h2ApVsao3KIlz2DATjKfpLsBzTN3SE
# 2R1mqzRzjx59fF6W1j0ZsJfqjFCRba9Xhn4QNx1rGhTfAgMBAAGjggEpMIIBJTAO
# BgNVHQ8BAf8EBAMCAYYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHQ4EFgQU6hbG
# aefjy1dFOTOk8EC+0MO9ZZYwHwYDVR0jBBgwFoAUrmwFo5MT4qLn4tcc1sfwf8hn
# U6AwPgYIKwYBBQUHAQEEMjAwMC4GCCsGAQUFBzABhiJodHRwOi8vb2NzcDIuZ2xv
# YmFsc2lnbi5jb20vcm9vdHI2MDYGA1UdHwQvMC0wK6ApoCeGJWh0dHA6Ly9jcmwu
# Z2xvYmFsc2lnbi5jb20vcm9vdC1yNi5jcmwwRwYDVR0gBEAwPjA8BgRVHSAAMDQw
# MgYIKwYBBQUHAgEWJmh0dHBzOi8vd3d3Lmdsb2JhbHNpZ24uY29tL3JlcG9zaXRv
# cnkvMA0GCSqGSIb3DQEBDAUAA4ICAQB/4ojZV2crQl+BpwkLusS7KBhW1ky/2xsH
# cMb7CwmtADpgMx85xhZrGUBJJQge5Jv31qQNjx6W8oaiF95Bv0/hvKvN7sAjjMaF
# /ksVJPkYROwfwqSs0LLP7MJWZR29f/begsi3n2HTtUZImJcCZ3oWlUrbYsbQswLM
# NEhFVd3s6UqfXhTtchBxdnDSD5bz6jdXlJEYr9yNmTgZWMKpoX6ibhUm6rT5fyrn
# 50hkaS/SmqFy9vckS3RafXKGNbMCVx+LnPy7rEze+t5TTIP9ErG2SVVPdZ2sb0rI
# Lmq5yojDEjBOsghzn16h1pnO6X1LlizMFmsYzeRZN4YJLOJF1rLNboJ1pdqNHrdb
# L4guPX3x8pEwBZzOe3ygxayvUQbwEccdMMVRVmDofJU9IuPVCiRTJ5eA+kiJJyx5
# 4jzlmx7jqoSCiT7ASvUh/mIQ7R0w/PbM6kgnfIt1Qn9ry/Ola5UfBFg0ContglDk
# 0Xuoyea+SKorVdmNtyUgDhtRoNRjqoPqbHJhSsn6Q8TGV8Wdtjywi7C5HDHvve8U
# 2BRAbCAdwi3oC8aNbYy2ce1SIf4+9p+fORqurNIveiCx9KyqHeItFJ36lmodxjzK
# 89kcv1NNpEdZfJXEQ0H5JeIsEH6B+Q2Up33ytQn12GByQFCVINRDRL76oJXnIFm2
# eMakaqoimzCCBnswggRjoAMCAQICEAEHZJsIsKf+fdZUqPL0KfYwDQYJKoZIhvcN
# AQELBQAwWzELMAkGA1UEBhMCQkUxGTAXBgNVBAoTEEdsb2JhbFNpZ24gbnYtc2Ex
# MTAvBgNVBAMTKEdsb2JhbFNpZ24gVGltZXN0YW1waW5nIENBIC0gU0hBMzg0IC0g
# RzQwHhcNMjMxMTA3MTcxMzQwWhcNMzQxMjA5MTcxMzQwWjBsMQswCQYDVQQGEwJC
# RTEZMBcGA1UECgwQR2xvYmFsU2lnbiBudi1zYTFCMEAGA1UEAww5R2xvYmFsc2ln
# biBUU0EgZm9yIE1TIEF1dGhlbnRpY29kZSBBZHZhbmNlZCAtIEc0IC0gMjAyMzEx
# MIIBojANBgkqhkiG9w0BAQEFAAOCAY8AMIIBigKCAYEAuaibPqmm3ELTQZ+KTUNH
# CfloixP7dY+ZXMqAQmHvjrrhcdZHkK2ZTWMDtu+pJqP7NupuFEf3101EdLIqXp0y
# XwRor7fJz1sLJy8oToLejrWzifrnEUnIJ0Bek28JIcbWX5jzt7qhQHKu3Q/fziFC
# BFQ46soi3QO5GqHgtxyXKHMsII0/ZrJ2mdo6yfZyllJ02H1lbuAib/6vRv1+r07I
# iYEyoZgrj3fnsqPVmp8f0YMgTk3vTDtRe5Ej4YNKom+4BOZkFEsuO3zptf2zbjZE
# QDb1viHm6ND6fveoTkaslLDQKXTisZeqfzjxieJ6t8psBTAYWG99W346kdR8b07/
# 6TF+pYI14S7/CmDqUoVXh3rkKq88ot952+B5j9+R7f8mPXZAS98bS/aCqOqDKK1T
# treW1x0tjO+/fYqelHxTqWQEa3zMFmcZMYKS6fQ6vNSIqL2O7k8Sedj/4JaQUH4B
# Ff/w42xeGvSvQMXlJz1G+DpBOP85SLTcBgH7OwgoaGmpAgMBAAGjggGoMIIBpDAO
# BgNVHQ8BAf8EBAMCB4AwFgYDVR0lAQH/BAwwCgYIKwYBBQUHAwgwHQYDVR0OBBYE
# FPijp+UjdVbRpaU7iW4WcctV1ogJMFYGA1UdIARPME0wCAYGZ4EMAQQCMEEGCSsG
# AQQBoDIBHjA0MDIGCCsGAQUFBwIBFiZodHRwczovL3d3dy5nbG9iYWxzaWduLmNv
# bS9yZXBvc2l0b3J5LzAMBgNVHRMBAf8EAjAAMIGQBggrBgEFBQcBAQSBgzCBgDA5
# BggrBgEFBQcwAYYtaHR0cDovL29jc3AuZ2xvYmFsc2lnbi5jb20vY2EvZ3N0c2Fj
# YXNoYTM4NGc0MEMGCCsGAQUFBzAChjdodHRwOi8vc2VjdXJlLmdsb2JhbHNpZ24u
# Y29tL2NhY2VydC9nc3RzYWNhc2hhMzg0ZzQuY3J0MB8GA1UdIwQYMBaAFOoWxmnn
# 48tXRTkzpPBAvtDDvWWWMEEGA1UdHwQ6MDgwNqA0oDKGMGh0dHA6Ly9jcmwuZ2xv
# YmFsc2lnbi5jb20vY2EvZ3N0c2FjYXNoYTM4NGc0LmNybDANBgkqhkiG9w0BAQsF
# AAOCAgEAcCtZLmsFUrUmVyG1zxDomvCsy3JUaG1VRZmWOVhHG9Bpayhs8JOLpkTL
# eMmrTmLEgh8FkN6sBpY7rqBGDYGG7JBw3LI1LstVLUNHb4t6TkE//rIhnEAx2K2P
# lTcaguvItw6noVwaqsBqSf0PigQHJsLZDs8mA30wRb9sUHoP6SQ2TICk6CJBK2Bm
# vKwLzzLIgH8qRsecwuUfD9ZV+QIMYcW8Yo9doyJh62qYeLBkLwmwDcm4CBxaXgYw
# JF1xg3Y4/UhqmF0/QkhvLIQ2/Ob+ksLScGNBg7X0oAplWtVB9IOoMBvI1ltuQOjD
# zeY34snpVVyLU8Tu4d+707WRirtnc7UI8KhIqw4b4ERwvuIE5xGp4T9QQZoMZgpW
# RcEFQflCFf0EppG1+kwWin5+BZqhh3RU/cenwOaTZ52kHSpcOgS1TtUXHqPije4+
# PAqBT1kx+wX/mBnTmLgG2EibSZPhAsdtsiyK3Ope29Rv/QesHjw2UXfxPiySZPWY
# 8E8rmhDz2l84+kpCyX9go5tJoTMLEM7CT6XTsoBYGSb6QwlKtXXVntivDa8etvtL
# SXj9X7Hqhu166ne60eznhjUJ+Vq7luH2Clf5/db+JBoAUL2eTciRGDfs0ijOD66X
# Rh3CfGDLu5pkrpa1ueXKeuV61nhBJN5myfZQF0Wlf9Mf6h7a7+gwggcXMIIFf6AD
# AgECAhEAhSUdQ5ifawEnC335IxMvYDANBgkqhkiG9w0BAQsFADBXMQswCQYDVQQG
# EwJHQjEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMS4wLAYDVQQDEyVTZWN0aWdv
# IFB1YmxpYyBDb2RlIFNpZ25pbmcgQ0EgRVYgUjM2MB4XDTI0MDgwMjAwMDAwMFoX
# DTI3MDgwMjIzNTk1OVowgf8xEDAOBgNVBAUTB0hSQiA1OTgxEzARBgsrBgEEAYI3
# PAIBAxMCREUxHTAbBgNVBA8TFFByaXZhdGUgT3JnYW5pemF0aW9uMQswCQYDVQQG
# EwJERTEWMBQGA1UECAwNTmllZGVyc2FjaHNlbjFIMEYGA1UECgw/R2VzZWxsLiBm
# w7xyIHdpc3NlbnNjaGFmdGxpY2hlIERhdGVudmVyYXJiZWl0dW5nIG1iSCBHw7Z0
# dGluZ2VuMUgwRgYDVQQDDD9HZXNlbGwuIGbDvHIgd2lzc2Vuc2NoYWZ0bGljaGUg
# RGF0ZW52ZXJhcmJlaXR1bmcgbWJIIEfDtnR0aW5nZW4wggIiMA0GCSqGSIb3DQEB
# AQUAA4ICDwAwggIKAoICAQCgs69OszRZoItbb6gVEZ9zeodJo75gYP+2yOaF38Sp
# Lsq1Mgu6Sn43dDdZCj/J3izkqReC0hbsIeiaY0D2tpOQAVY045mu0JXVJOufFIkl
# lOMe0DjBTWoTAqO9NjJFTQkzj7rfhy2odHZnkR3vPlURW6dvxGKFAhlluVJNQxYr
# XJZokhT6/7sfQgRpbHpxApl/eISdWTyXMPiP7g5S9UTfjiA8/nQpbEeSYLL/4zxX
# PCkF7vNm/g4hTnmdYa7HGGUeWPly8tE3sRG1v5y+OOIJ9r97oWCOe8O/AH08MUDd
# tvHSljE3NAmJ3uayaThagib99rHHmZ5UDk++yvzboLjZvO67+9QiQT0AgcEn59bi
# y+w/wqJLVAY2u1nN3ExmD/JsXj2u2PVylV16YdhrhvRxdzlFnp5jdYygcAQqliDN
# Alfat7C7/c8aKZAiurTDOxY5H2x0/BfBoVxnu3Wzl3dSs0ych5EhBzOIQSJmv6cU
# F471d2b+pufLCMSxYss/UTjq2wLpPkZ7Ab/Y44ECUgcTO5+fRkPgCRXgloD6r8rJ
# uSXatX6rgTp0t94QseXA0WODkoJOR/Aro1+zG0ENTmsjGbA5YTE77nFuoZZ54YYt
# Nidk5PWx/FFjFdo43k/DpXrAp71OngjS7ZNI45K+jMxtxBTvlTD/DPDZE9KNeqXx
# iwIDAQABo4IBszCCAa8wHwYDVR0jBBgwFoAUgTKSQSsozUbIxKLGKjkS7EipPxQw
# HQYDVR0OBBYEFPbsQTDoEnJ6DHI/Ep2FCf8qcZOiMA4GA1UdDwEB/wQEAwIHgDAM
# BgNVHRMBAf8EAjAAMBMGA1UdJQQMMAoGCCsGAQUFBwMDMEkGA1UdIARCMEAwNQYM
# KwYBBAGyMQECAQYBMCUwIwYIKwYBBQUHAgEWF2h0dHBzOi8vc2VjdGlnby5jb20v
# Q1BTMAcGBWeBDAEDMEsGA1UdHwREMEIwQKA+oDyGOmh0dHA6Ly9jcmwuc2VjdGln
# by5jb20vU2VjdGlnb1B1YmxpY0NvZGVTaWduaW5nQ0FFVlIzNi5jcmwwewYIKwYB
# BQUHAQEEbzBtMEYGCCsGAQUFBzAChjpodHRwOi8vY3J0LnNlY3RpZ28uY29tL1Nl
# Y3RpZ29QdWJsaWNDb2RlU2lnbmluZ0NBRVZSMzYuY3J0MCMGCCsGAQUFBzABhhdo
# dHRwOi8vb2NzcC5zZWN0aWdvLmNvbTAlBgNVHREEHjAcoBoGCCsGAQUFBwgDoA4w
# DAwKREUtSFJCIDU5ODANBgkqhkiG9w0BAQsFAAOCAYEAH/6VMP9NBbCGHNUVO3L9
# gD8WZx7st0NHKFfguC48IvYU+bayLJf+dAcHo1ZipHiJZIX72QD93VGcjOa1XI54
# DD1KKg2WUv9DUOQjrdERDGmxUvBA8HqIKGW2smwWGbTH3WAOlTMxdWDEFWMqeU0P
# 9orytYpONk0+UCUA/x32IyXsneh5KVX2HVXDV89pgErrC+i4938b+Ug4UPer3ZES
# k+iOBSyazCOGSzzN/HOLgiiRVQ/LsoRTVl7bztp4NRjHa0WIyjqDUbsPhaZIb+N3
# jurx8NS8fXc4SbUyBVOFvtiXbZvfVKir11YJl80PX9daoGUVcjKa9DvnutY3YKmU
# xpNHKlMfApT6TTLtKhs5oEWUswfGjtsEjgA9t8A5xWyyp0a/1+YMDeyqWjkYHKJL
# oLUUUZAUT33vDTuTD2kzQ/4s5goZj6fOXg/iAO4i8Lb3ODAdsGZ5Tbdn5NByTTml
# 3NzC8ow2QeR7r6sbbwuX7frOpyVzwrMsKTm/G5I44K3nMYIGVTCCBlECAQEwbDBX
# MQswCQYDVQQGEwJHQjEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMS4wLAYDVQQD
# EyVTZWN0aWdvIFB1YmxpYyBDb2RlIFNpZ25pbmcgQ0EgRVYgUjM2AhEAhSUdQ5if
# awEnC335IxMvYDANBglghkgBZQMEAgEFAKBMMBkGCSqGSIb3DQEJAzEMBgorBgEE
# AYI3AgEEMC8GCSqGSIb3DQEJBDEiBCDCtqbM0kRlQIcRd3snJpsV6rFOlOj8ME6G
# ENfx3OFEeTANBgkqhkiG9w0BAQEFAASCAgACMmFM3/yfYdo7snp6UHW1NF4MIDtu
# Ez6DYH0n0Q6ywgXTqcCA2JRRcPnMjOoYl/biHYwDlUdMXQysc2LgUjPV0srLJduN
# iWUqiZUQKZS+QHBUvQA/0bQKYusXXFj5nAxPUtRjcXdn7ih3Dq84ob2xnxgeJl/t
# Nax3fV7YcnsVx+VJC0V8fj1HBlEFjdvfMh1TTX4ljRc85ngmzP+ixsFXb/cj+mE1
# pNSSVe1Ppeayg2VdjUD8ny1F45CjMiOy3IMXGBB0kQdowLbhuSPbygxF07V/GLMd
# /DBzIngbezIyozcrR+rVKpu1/HQDlHPBpjsmbZGF08n8+YxTWC6baP0vYc338WCo
# 5LupfsQ+wiDJRg1tpJXp9LZ7JXokyBa020t41+O3E3ltkwywrBrqed9H5d1F5QN+
# jU7EVITy0AAh6yHZFPYm+wYOvsqi5Rs1VjxG0QL5+j/Xfmm+NEJ4TqNK88lsmAzd
# FXgaM8zn1ObgZ4JDx+YDdtsDfM75tf+hDkykDLs72lE6QFEnN6DE0++svP8f1ICU
# zacL+ThckLDm0WCSH0kOxbCNCsa5WZSOeKH5aN3FZtk6VwQ8/HlP2W0pQlvPN1Pz
# pb/WHAHidr5qnvl5/xXsz+bMmzA5iK8/ytxZ5lh44hwH4CYa5He14XEJeT2FBFZm
# 7vpohI6pVfYO4qGCA2wwggNoBgkqhkiG9w0BCQYxggNZMIIDVQIBATBvMFsxCzAJ
# BgNVBAYTAkJFMRkwFwYDVQQKExBHbG9iYWxTaWduIG52LXNhMTEwLwYDVQQDEyhH
# bG9iYWxTaWduIFRpbWVzdGFtcGluZyBDQSAtIFNIQTM4NCAtIEc0AhABB2SbCLCn
# /n3WVKjy9Cn2MAsGCWCGSAFlAwQCAaCCAT0wGAYJKoZIhvcNAQkDMQsGCSqGSIb3
# DQEHATAcBgkqhkiG9w0BCQUxDxcNMjQxMDI1MTQwMDUxWjArBgkqhkiG9w0BCTQx
# HjAcMAsGCWCGSAFlAwQCAaENBgkqhkiG9w0BAQsFADAvBgkqhkiG9w0BCQQxIgQg
# ZO6SW7+XNFhJdWUYwWByaSwllB+Xqxcm0fS93JLzv7owgaQGCyqGSIb3DQEJEAIM
# MYGUMIGRMIGOMIGLBBRE05OczRuIf4Z6zNqB7K8PZfzSWTBzMF+kXTBbMQswCQYD
# VQQGEwJCRTEZMBcGA1UEChMQR2xvYmFsU2lnbiBudi1zYTExMC8GA1UEAxMoR2xv
# YmFsU2lnbiBUaW1lc3RhbXBpbmcgQ0EgLSBTSEEzODQgLSBHNAIQAQdkmwiwp/59
# 1lSo8vQp9jANBgkqhkiG9w0BAQsFAASCAYC48CJoHH88dQBGArqOjy/u2hZ4CdL6
# un7jmu2P7HvL26t0b+1angX7UR1DR/Rixl7HyiHBv215/ha7T9AHnluOlyzpVPwV
# zFit0PD7O95btM0PNoJHtHE4iGKXOKEc9HaWfYobEQjEGffNixYXCkCjN+wCDopc
# P2RcpS5thNgL+fodwEj62UxDc8wqx66m4UDQMqOnI6wfGuL41q5THQpkrPGD/0ix
# fpUdk/39g5SGhaaz+qDx0bGrc0sXtzPKFzeflw46YNHNLEsa9cF15G4F61dyyWFK
# qF+xl1p/ykzaB8ZC6eBg+DRu5UYW8M5TcMLLpuWFsqQl2LT+kwdHdrp4ufrMqtqJ
# daX2GHtV0thuuned4NMZtOPvpJBSjVFJY98XL/3CrPp0mzfMlEfoZPksqKqqumlu
# kjdCr/dEoVoxoiXGndnHNweWniZDYQIyxe8XMQ9R0GPZccvOTZoMq5ATqYYQ2Oss
# IByf1RBRPdsBSkNr5HB1qneQttvu7cEpl2E=
# SIG # End signature block
